//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.BasicDataTypesTest
{
    
    
    /// <summary>
    /// A class that exposes the IBasicDataTypesTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class BasicDataTypesTestProvider : IFeatureProvider
    {
        
        private IBasicDataTypesTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(BasicDataTypesTestProvider).Assembly, "BasicDataTypesTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public BasicDataTypesTestProvider(IBasicDataTypesTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EchoStringValueRequestDto, EchoStringValueResponseDto>("EchoStringValue", EchoStringValue);
            registration.RegisterUnobservableCommand<EchoIntegerValueRequestDto, EchoIntegerValueResponseDto>("EchoIntegerValue", EchoIntegerValue);
            registration.RegisterUnobservableCommand<EchoRealValueRequestDto, EchoRealValueResponseDto>("EchoRealValue", EchoRealValue);
            registration.RegisterUnobservableCommand<EchoBooleanValueRequestDto, EchoBooleanValueResponseDto>("EchoBooleanValue", EchoBooleanValue);
            registration.RegisterUnobservableCommand<EchoDateValueRequestDto, EchoDateValueResponseDto>("EchoDateValue", EchoDateValue);
            registration.RegisterUnobservableCommand<EchoTimeValueRequestDto, EchoTimeValueResponseDto>("EchoTimeValue", EchoTimeValue);
            registration.RegisterUnobservableCommand<EchoTimestampValueRequestDto, EchoTimestampValueResponseDto>("EchoTimestampValue", EchoTimestampValue);
            registration.RegisterUnobservableProperty("StringValue", GetStringValue);
            registration.RegisterUnobservableProperty("IntegerValue", GetIntegerValue);
            registration.RegisterUnobservableProperty("RealValue", GetRealValue);
            registration.RegisterUnobservableProperty("BooleanValue", GetBooleanValue);
            registration.RegisterUnobservableProperty("DateValue", GetDateValue);
            registration.RegisterUnobservableProperty("TimeValue", GetTimeValue);
            registration.RegisterUnobservableProperty("TimestampValue", GetTimestampValue);
        }
        
        /// <summary>
        /// Executes the Echo String Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoStringValueResponseDto EchoStringValue(EchoStringValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoStringValueResponseDto(_implementation.EchoStringValue(request.StringValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoStringValue/Parameter/Str" +
                                "ingValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "stringValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoStringValue/Parameter/Str" +
                            "ingValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Integer Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoIntegerValueResponseDto EchoIntegerValue(EchoIntegerValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoIntegerValueResponseDto(_implementation.EchoIntegerValue(request.IntegerValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoIntegerValue/Parameter/In" +
                                "tegerValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "integerValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoIntegerValue/Parameter/In" +
                            "tegerValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Real Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoRealValueResponseDto EchoRealValue(EchoRealValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoRealValueResponseDto(_implementation.EchoRealValue(request.RealValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoRealValue/Parameter/RealV" +
                                "alue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "realValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoRealValue/Parameter/RealV" +
                            "alue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Boolean Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoBooleanValueResponseDto EchoBooleanValue(EchoBooleanValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoBooleanValueResponseDto(_implementation.EchoBooleanValue(request.BooleanValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoBooleanValue/Parameter/Bo" +
                                "oleanValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "booleanValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoBooleanValue/Parameter/Bo" +
                            "oleanValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Date Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoDateValueResponseDto EchoDateValue(EchoDateValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoDateValueResponseDto(_implementation.EchoDateValue(request.DateValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoDateValue/Parameter/DateV" +
                                "alue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "dateValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoDateValue/Parameter/DateV" +
                            "alue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Time Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoTimeValueResponseDto EchoTimeValue(EchoTimeValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoTimeValueResponseDto(_implementation.EchoTimeValue(request.TimeValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimeValue/Parameter/TimeV" +
                                "alue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "timeValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimeValue/Parameter/TimeV" +
                            "alue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Timestamp Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoTimestampValueResponseDto EchoTimestampValue(EchoTimestampValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoTimestampValueResponseDto(_implementation.EchoTimestampValue(request.TimestampValue.TryExtract(_server, "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimestampValue/Parameter/" +
                                "TimestampValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "timestampValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimestampValue/Parameter/" +
                            "TimestampValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the String Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.StringDto> GetStringValue()
        {
            return new PropertyResponse<Tecan.Sila2.StringDto>(new Tecan.Sila2.StringDto(_implementation.StringValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Integer Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.IntegerDto> GetIntegerValue()
        {
            return new PropertyResponse<Tecan.Sila2.IntegerDto>(new Tecan.Sila2.IntegerDto(_implementation.IntegerValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Real Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.RealDto> GetRealValue()
        {
            return new PropertyResponse<Tecan.Sila2.RealDto>(new Tecan.Sila2.RealDto(_implementation.RealValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Boolean Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.BooleanDto> GetBooleanValue()
        {
            return new PropertyResponse<Tecan.Sila2.BooleanDto>(new Tecan.Sila2.BooleanDto(_implementation.BooleanValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Date Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.DateDto> GetDateValue()
        {
            return new PropertyResponse<Tecan.Sila2.DateDto>(new Tecan.Sila2.DateDto(_implementation.DateValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Time Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.TimeDto> GetTimeValue()
        {
            return new PropertyResponse<Tecan.Sila2.TimeDto>(new Tecan.Sila2.TimeDto(_implementation.TimeValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Timestamp Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<Tecan.Sila2.TimestampDto> GetTimestampValue()
        {
            return new PropertyResponse<Tecan.Sila2.TimestampDto>(new Tecan.Sila2.TimestampDto(_implementation.TimestampValue, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoStringValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoStringValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoIntegerValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoIntegerValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoRealValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoRealValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoBooleanValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoBooleanValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoDateValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoDateValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimeValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoTimeValue");
            }
            if ((commandIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Command/EchoTimestampValue"))
            {
                return typeof(IBasicDataTypesTest).GetMethod("EchoTimestampValue");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/StringValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("StringValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/IntegerValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("IntegerValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/RealValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("RealValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/BooleanValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("BooleanValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/DateValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("DateValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/TimeValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("TimeValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/BasicDataTypesTest/v1/Property/TimestampValue"))
            {
                return typeof(IBasicDataTypesTest).GetProperty("TimestampValue");
            }
            return null;
        }
    }
}

